<!-- 证书记录列表 -->
<script lang="ts" setup name="person">
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { StaffListType, StaffType } from './person-interface'
import { CertificateListList, getCertificateList, getCertificateRemind, getCertificateRemove, getCertificateUpload } from '@/api/measure/person'
// import { uploadApi } from '@/api/system/notice'
import { printJSON } from '@/utils/printUtils'
import { getDeptTreeList } from '@/api/system/dept'
import { exportFile } from '@/utils/exportUtils'
// import type { DeptTreeNode } from '@/views/system/dept/dept-interface'
import { toTreeList } from '@/utils/structure'
import type { TableColumn } from '@/components/NormalTable/table_interface'

const props = defineProps({
  isRemind: {
    type: Boolean,
    default: false,
  },
  authority: {
    type: String,
    default: 'certificateLog',
  },
})
const $route = useRoute()
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const searchQuery = reactive<StaffListType>({
  staffNo: '', // 人员编号
  name: '', // 姓名
  deptId: '', // 工作部门
  // major: '', // 计量专业
  verifierCertificateNo: '', // 证书号
  certificateStatus: '', // 证书状态
  userId: localStorage.login_username,
  remindType: '',
  limit: 20,
  offset: 1,
  ids: [] as string[],
}) // 查询参数
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref<TableColumn[]>([
  { text: '人员编号', value: 'staffNo', align: 'center', width: '160' },
  { text: '姓名', value: 'name', align: 'center' },
  { text: '性别', value: 'sex', align: 'center', width: '70' },
  { text: '工作部门', value: 'deptName', align: 'center' },
  { text: '技术职务', value: 'technologyJob', align: 'center' },
  { text: '行政职务', value: 'administrationJob', align: 'center' },
  { text: '证书号', value: 'certificateNo', align: 'center' },
  { text: '发证单位', value: 'certificateCompany', align: 'center' },
  { text: '发证日期', value: 'certificateDate', align: 'center', width: '110' },
  { text: '证书有效日期', value: 'validDate', align: 'center', width: '110' },
  { text: '证书状况', value: 'certificateStatusName', align: 'center' },
]) // 表格
const certificateStatusList = ref([
  {
    name: '已失效',
    id: '1',
    value: '1',
  },
  {
    name: '正常',
    id: '0',
    value: '0',
  },
])
const list = ref([]) // 表格数据
const deptProps = reactive({
  parent: 'pid', value: 'id', label: 'name', children: 'children',
})
// 获取所有部门
const deptList = ref([])
const getDeptList = async () => {
  getDeptTreeList().then((res) => {
    deptList.value = toTreeList(res.data, '0', true)
  })
}
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  if (props.isRemind) {
    searchQuery.remindType = 'remind'
  }
  getCertificateList(searchQuery).then((res) => {
    if (res.code === 200) {
      res.data.records = res.data.records.map((item: any) => ({ ...item, sex: item.sex == '1' ? '男' : '女', certificateStatus: item.certificateStatus == '0' ? '正常' : '已失效', validDate: item.validDate.split(' ')[0], certificateDate: item.certificateDate.split(' ')[0] }))
      console.log(res.data.records)
      switch (searchQuery.certificateStatus) {
        case '正常':
          list.value = res.data.records.filter((item: any) => item.certificateStatus === '正常')
          break
        case '已失效':
          list.value = res.data.records.filter((item: any) => item.certificateStatus === '已失效')
          break
        default:
          list.value = res.data.records
          break
      }
      total.value = Number(res.data.total)
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 详情
const detail = (row: StaffType) => {
  $router.push({
    name: 'CertificateLogDetail',
    params: {
      type: 'detail',
    },
    query: {
      ...row,
      title: '详情',
      name: props.isRemind ? '证书状况' : '证书记录',
    },
  })
}
// 编辑
const update = (row: StaffType) => {
  $router.push({
    name: 'CertificateLogDetail',
    params: {
      type: 'edit',
    },
    query: {
      ...row,
      title: '编辑',
      name: props.isRemind ? '证书状况' : '证书记录',
    },
  })
}

// 删除
const remove = (row: StaffType) => {
  ElMessageBox.confirm(
    `确认删除${row.name}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      getCertificateRemove({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          getList()
        }
      })
    })
}
// 提醒
const remind = (row: StaffType) => {
  ElMessageBox.confirm(
    `确认提醒${row.name}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    getCertificateRemind({ id: row.id }).then((res) => {
      if (res.code == 200) {
        ElMessage({
          type: 'success',
          message: '操作成功',
        })
        getList()
      }
    })
  })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  searchQuery.staffNo = ''
  searchQuery.name = ''
  searchQuery.deptId = ''
  searchQuery.certificateStatus = ''
  searchQuery.verifierCertificateNo = ''
  getList()
}
// 模板下载
const templateDownload = () => {

}
// 新增
const add = () => {
  $router.push({
    name: 'CertificateLogDetail',
    params: {
      type: 'edit',
    },
    query: {
      title: '新建',
      name: props.isRemind ? '证书状况' : '证书记录',
    },
  })
}
// 表格被选中的行
const selectList = ref<StaffType[]>([])
// 表格多选
const multiSelect = (row: StaffType[]) => {
  selectList.value = row
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (selectList.value.length) {
    selectList.value.forEach((item) => {
      searchQuery.ids?.push(item.id as string)
    })
  }
  CertificateListList({ ...searchQuery }).then((res) => {
    exportFile(res.data, '证书记录列表')
    loading.close()
    searchQuery.ids = []
  }).catch((_) => {
    loading.close()
  })
}
// 打印
function printList() {
  const selectIds = selectList.value.map((item: StaffType) => item.id)
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (selectIds.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, props.isRemind ? '证书到期提醒' : '证书记录列表')
  }
  else if (selectIds.length > 0) {
    const printList = list.value.filter((item: StaffType) => selectIds.includes(item.id))
    printJSON(printList, properties, props.isRemind ? '证书到期提醒' : '证书记录列表')
  }
  else {
    ElMessage('无可打印内容')
  }
}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传图片
  // console.log(event.target.files)
  // if (event.target.files[0].type === 'application/pdf') {
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    getCertificateUpload(fd).then((res) => {
      if (res.code === 200) {
        ElMessage.success('上传成功')
      }
      else {
        ElMessage.error(res.message)
      }
    })
  }
//   }
//   else {
//     ElMessage.error('请上传pdf格式')
//   }
}
// 批量导入
const batchImport = () => {
  fileRef.value.click()
}
onMounted(() => {
  getDeptList()
  getList()
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <!-- 筛选条件 -->
      <search-area :need-clear="true" @search="search" @clear="reset">
        <search-item>
          <el-input v-model="searchQuery.staffNo" placeholder="人员编号" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.name" placeholder="姓名" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <dept-select v-model="searchQuery.deptId" :data="deptList" placeholder="工作部门" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.verifierCertificateNo" placeholder="证书号" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-select v-model="searchQuery.certificateStatus" class="m-2" placeholder="证书状况" clearable>
            <el-option
              v-for="item in certificateStatusList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
      </search-area>
      <table-container>
        <!-- 表头区域 -->
        <template #btns-right>
          <input v-show="(searchQuery.limit === 0)" ref="fileRef" type="file" multiple @change="onFileChange">
          <icon-button v-if="!props.isRemind && proxy.hasPerm(`/measure/person/${authority}/add`)" icon="icon-add" title="新建" @click="add" />
          <!-- <icon-button v-if="!props.isRemind && proxy.hasPerm(`/measure/person/${authority}/import`)" icon="icon-import" title="批量导入" @click="batchImport" /> -->
          <!-- <icon-button v-if="!props.isRemind && proxy.hasPerm(`/measure/person/${authority}/mould`)" icon="icon-template" title="模板下载" @click="templateDownload" /> -->
          <icon-button v-if="proxy.hasPerm(`/measure/person/${authority}/export`)" icon="icon-export" title="导出" @click="exportExcelBtn" />
          <icon-button v-if="proxy.hasPerm(`/measure/person/${authority}/print`)" icon="icon-print" title="打印" @click="printList" />
        </template>
        <!-- 表格区域 -->
        <normal-table
          id="print"
          :data="list" :total="total" :columns="columns"
          :is-showmulti-select="true"
          :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
          :list-loading="loadingTable"
          :is-multi="true"
          @change="changePage"
          @multi-select="multiSelect"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column fixed="right" label="操作" align="center" :width="props.isRemind ? '140' : '110'">
              <template #default="{ row }">
                <el-button v-if="props.isRemind && proxy.hasPerm(`/measure/person/${authority}/remind`)" size="small" type="primary" link @click="remind(row)">
                  提醒
                </el-button>
                <el-button v-if="!props.isRemind && proxy.hasPerm(`/measure/person/${authority}/update`)" size="small" type="primary" link @click="update(row)">
                  编辑
                </el-button>
                <el-button v-if="proxy.hasPerm(`/measure/person/${authority}/detail`)" size="small" type="primary" link @click="detail(row)">
                  详情
                </el-button>
                <el-button v-show="false" v-if="props.isRemind && proxy.hasPerm(`/measure/person/${authority}/delete`)" size="small" type="danger" link @click="remove(row)">
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 130px !important;
}

.normal-date {
  width: 130px !important;
}

.normal-select {
  width: 130px !important;
}

:deep(.el-table__header) {
  background-color: #bbb;
}
</style>
